#include <stdio.h> 
#include <string.h> 
#include <stdlib.h> 
#include <getopt.h> 

void *xrealloc(void *ptr, size_t amount); //   realloc,    
char *myname; //    

int main(int argc, char *argv[]) 
{	 
	int rs; 
	int do_help = 0, do_version = 0; //   
	char *txt; // ,    
	txt = malloc(1); 
	struct option longopts[] = 
	{ 
		{ "help", no_argument, &do_help, 1 }, 
		{ "version", no_argument, &do_version, 1 }, 
	}; 
	myname = argv[0]; 
	opterr = 0; //     getopt_long() 
	/*    optstring  ,  getopt_long()     */ 
	while ((rs = getopt_long(argc, argv, "-", longopts, NULL)) != -1) 
	{ 
		switch (rs) 
		{ 
			case 0: // getopt_long()   ,   
				break; 
			case 1: //  case ,    optstring   
				txt = xrealloc(txt, strlen(optarg) + strlen(txt) + 2); 
				strcat(txt, optarg); 
				strcat(txt, " "); 
				break; 
			case ':': //  case   .    ,   . 
				fprintf(stderr, "%s:  '-%c'  \n", argv[0], optopt); 
				return 1; 
			case '?': 
			default: 
				fprintf(stderr, "%s:  '-%c' \n", argv[0], optopt); 
				return 1; 
		} 
	} 
	if (do_help) 
	{ 
		printf( ": %s [] []\n" 
			"    () ,    , 'y'.\n\n" 
			"    --help          \n" 
			"    --version        \n", myname); 
		free(txt); 
		return 0; 
	} 
	if (do_version) 
	{ 
		printf( "%s\n" 
			"  .\n", myname); 
		free(txt); 
		return 0; 
	} 
	if (argc < 2) 
		strcpy(txt, "y"); 
	while (1) 
		printf("%s\n", txt); 
	return 0; 
} 
 
void *xrealloc(void *ptr, size_t amount) 
{ 
	void *p = realloc(ptr, amount); 
	if (p == NULL) 
	{ 
		fprintf(stderr, "%s:    \n", myname); 
		exit(1); 
	} 
	return p; 
}